 clear all; close all; clc;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% V Y T V O R E N I    V S T U P N I C H    D A T
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Ts = 0.2;                   % perioda vzorkovani
u=2;                        % velikost zadane hodnoty
noise=0;                    % velikost sumu
time=5;                     % delka simulace
p = tf('p');
Gs = 1/(p+1);     % identifikovany system
Gz = c2d(Gs,Ts);
[num,den] = tfdata(Gz,'v');
num(2) = 0.5;
den(2) = -0.5;
sim('model.mdl',time)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% U P R A V A    V S T U P N I C H    D A T
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[m,n] = size(Data);         %m...radky, n...sloupce
fi(:,1) = Data(1:m-1,3);    %fi(:,1) u
fi(:,2) = -Data(1:m-1,2);   %fi(:,2) -y 
Y = Data(2:m,2);            %Y...vektor vzoru
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% I N I C I A L I Z A C E    G R A D I E N T N I    M E T O D Y
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
iterm=30;
theta = [1 0]';             %hledane parametry
etap = 0;               %krok (na miste 0.00797)
J = -fi;
for iter=1:iterm
    E = Y - fi*theta;  %chyba
    I = E'*E;
    g = J'*E;   %gradient 
    if (E~=0)
        if (etap==0) 
            eta = g'*g*inv(g'*J'*J*g);                                 
        else
            eta=etap;
        end
        theta = theta - eta*g
    end 
    I1(iter) = I;
    w(:,iter) = theta; 
end

[b1 a1] = meshgrid(0:0.1:1,-1:0.1:0);
[m,n] = size(b1);
for im = 1:m
    for in = 1:m
        Ym = fi(:,1).*b1(im,in) + fi(:,2).*a1(im,in);
        II(im,in) = 1/2*sum((Y - Ym).^2);
    end
end
figure(1)
meshc(b1,a1,II)
hold on
plot3(w(1,:),w(2,:),I1,'ko')

figure(2)
plot(1:iterm,w(1,:))
hold on
plot(1:iterm,w(2,:),'r')
title('Parametry b1, a1')

figure(3)
plot(1:iterm,I1)
title('Kriterialni funkce')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% P O R O V N A N I    E T A
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
iterm2 = 30;
% eta2 = [0.0001 0.0005 0.001 0.005 0.006 0.0075 0.00797 0.00798];               %krok
eta2 = [0.0001 0.0005 0.005 0.0075 0.0077 0.00796 0.008];
for kk=1:length(eta2)
    theta = [1 0]';             %hledane parametry
    eta = eta2(kk);
    for iter=1:iterm2
        E = Y - fi*theta;  %chyba
        I = 1/2*sum(E.^2);
        g = J'*E;   %gradient 
        theta = theta - eta*g;
        I2(kk,iter) = I;
        w2(kk*2-1:kk*2,iter) = theta;
    end   
end

theta = [1 0]';             %hledane parametry
for iter=1:iterm2
    E = Y - fi*theta;  %chyba
    I = 1/2*sum(E.^2);
    g = J'*E;   %gradient 
    eta = g'*g*inv(g'*J'*J*g);                                 
    theta = theta - eta*g;
    I3(iter) = I;
    w3(:,iter) = theta; 
end

figure(4)
meshc(b1,a1,II)
% title('Porovnani eta')
title('Steepest Descent s optimalnim krokem')
hold on
% plot3(w3(1,:),w3(2,:),I3,'yh')
plot3(w3(1,:),w3(2,:),I3,'ko')
% pause
% plot3(w2(1,:),w2(2,:),I2(1,:),'ko')
xlabel('b1');
ylabel('a1');
zlabel('I')
% pause
% plot3(w2(3,:),w2(4,:),I2(2,:),'r+')
% pause
% plot3(w2(5,:),w2(6,:),I2(3,:),'m*')
% pause
% plot3(w2(7,:),w2(8,:),I2(4,:),'cs')
% pause
% plot3(w2(9,:),w2(10,:),I2(5,:),'kv')
% pause
% plot3(w2(11,:),w2(12,:),I2(6,:),'g*')
% pause
% plot3(w2(13,:),w2(14,:),I2(7,:),'kd')
% pause
% plot3(w2(15,:),w2(16,:),I2(8,:),'rp')
% pause
% % plot3(w2(15,:),w2(16,:),I2(8,:),'ko')

% figure(5)
% plot(1:iterm2,I2)
% hold on
% plot(1:iterm2,I3,'k')
% title('Porovnani eta')
% legend('0.0001','0.0005','0.001','0.005','0.006','0.0075','0.00797','0.008','optimal')
figure(5)
plot(0:iterm2-1,I2)
hold on
plot(0:iterm2-1,I3,'k')
title('Porovnani eta')
xlabel('iterace')
ylabel('I')
legend('0.0001','0.0005','0.005','0.0075','0.0077','0.00796','0.008','optimal')

