function [y w fi wnum unum ynum] = fmodel(model)
switch model
    case 'arx2r'
        syms y w1 w2 w3 w4 uk1 uk2 yk1 yk2
        y = w1*uk1+w2*uk2-w3*yk1-w4*yk2;
        w = [w1 w2 w3 w4];
        fi = [uk1 uk2 yk1 yk2];
        wnum = 4;
        unum = 2;
        ynum = 2;
    case 'arx3r'
        syms y w1 w2 w3 w4 w5 w6 uk1 uk2 uk3 yk1 yk2 yk3
        y = w1*uk1+w2*uk2+w3*uk3-w4*yk1-w5*yk2-w6*yk3;
        w = [w1 w2 w3 w4 w5 w6];
        fi = [uk1 uk2 uk3 yk1 yk2 yk3];
        wnum = 6;
        unum = 3;
        ynum = 3;
    case 'arx4r'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 uk1 uk2 uk3 uk4 yk1 yk2 yk3 yk4
        y = w1*uk1+w2*uk2+w3*uk3+w4*uk4-w5*yk1-w6*yk2-w7*yk3-w8*yk4;
        w = [w1 w2 w3 w4 w5 w6 w7 w8];
        fi = [uk1 uk2 uk3 uk4 yk1 yk2 yk3 yk4];
        wnum = 8;
        unum = 4;
        ynum = 4;
    case 'nde2r2p'
        syms y w1 w2 w3 w4 w5 w6 w7 uk1 uk2 yk1 yk2
        y = w1*uk1+w2*uk2+w3*yk1+w4*yk2+w5*yk1^2+w6*yk2^2+w7*yk1*yk2;
        w = [w1 w2 w3 w4 w5 w6 w7];
        fi = [uk1 uk2 yk1 yk2];
        wnum = 7;
        unum = 2;
        ynum = 2;
    case 'nde2r3p'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 uk1 uk2 yk1 yk2
        y = w1*uk1+w2*uk2+w3*yk1+w4*yk2+w5*yk1^2+w6*yk2^2+w7*yk1*yk2+w8*yk1^3+w9*yk2^3+w10*yk1^2*yk2+w11*yk1*yk2^2;
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 ];
        fi = [uk1 uk2 yk1 yk2];
        wnum = 11;
        unum = 2;
        ynum = 2;
    case 'nde3r2p'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 uk1 uk2 uk3 yk1 yk2 yk3
        y = w1*uk1+w2*uk2+w3*uk3+w4*yk1+w5*yk2+w6*yk3+w7*yk1^2+w8*yk2^2+w9*yk3^2+w10*yk1*yk2+w11*yk1*yk3+w12*yk2*yk3;
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12];
        fi = [uk1 uk2 uk3 yk1 yk2 yk3];
        wnum = 12;
        unum = 3;
        ynum = 3;
    case 'nde3r3p'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 uk1 uk2 uk3 yk1 yk2 yk3
        y = w1*uk1+w2*uk2+w3*uk3+w4*yk1+w5*yk2+w6*yk3+w7*yk1^2+w8*yk2^2+w9*yk3^2+w10*yk1*yk2+w11*yk1*yk3+w12*yk2*yk3+w13*yk1^3+w14*yk2^3+w15*yk3^3+w16*yk1^2*yk2+w17*yk1^2*yk3+w18*yk1*yk2^2+w19*yk2^2*yk3+w20*yk1*yk3^2+w21*yk2*yk3^2+w22*yk1*yk2*yk3;
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22];
        fi = [uk1 uk2 uk3 yk1 yk2 yk3];
        wnum = 22;
        unum = 3;
        ynum = 3;
    case 'pvs2r2p'
        syms y w1 w2 w3 w4 w5 w6 w7 uk1 uk2 yk1 yk2
        y = w1*uk1+w2*uk2+w3*yk1+w4*yk2+w5*uk1^2+w6*uk2^2+w7*uk1*uk2;
        w = [w1 w2 w3 w4 w5 w6 w7];
        fi = [uk1 uk2 yk1 yk2];
        wnum = 7;
        unum = 2;
        ynum = 2;
    case 'pvs2r3p'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 uk1 uk2 yk1 yk2
        y = w1*uk1+w2*uk2+w3*yk1+w4*yk2+w5*uk1^2+w6*uk2^2+w7*uk1*uk2+w8*uk1^3+w9*uk2^3+w10*uk1^2*uk2+w11*uk1*uk2^2;
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11];
        fi = [uk1 uk2 yk1 yk2];
        wnum = 11;
        unum = 2;
        ynum = 2;
    case 'pvs3r2p'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 uk1 uk2 uk3 yk1 yk2 yk3
        y = w1*uk1+w2*uk2+w3*uk3+w4*yk1+w5*yk2+w6*yk3+w7*uk1^2+w8*uk2^2+w9*uk3^2+w10*uk1*uk2+w11*uk1*uk3+w12*uk2*uk3;
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12];
        fi = [uk1 uk2 uk3 yk1 yk2 yk3];
        wnum = 12;
        unum = 3;
        ynum = 3;
    case 'pvs3r3p'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 uk1 uk2 uk3 yk1 yk2 yk3
        y = w1*uk1+w2*uk2+w3*uk3+w4*yk1+w5*yk2+w6*yk3+w7*uk1^2+w8*uk2^2+w9*uk3^2+w10*uk1*uk2+w11*uk1*uk3+w12*uk2*uk3+w13*uk1^3+w14*uk2^3+w15*uk3^3+w16*uk1^2*uk2+w17*uk1^2*uk3+w18*uk1*uk2^2+w19*uk2^2*uk3+w20*uk1*uk3^2+w21*uk2*uk3^2+w22*uk1*uk2*uk3;
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22];
        fi = [uk1 uk2 uk3 yk1 yk2 yk3];
        wnum = 22;
        unum = 3;
        ynum = 3;
    case 'kg2r2p'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 uk1 uk2 yk1 yk2
        y = w1*uk1+w2*uk2+w3*yk1+w4*yk2+w5*uk1^2+w6*uk2^2+w7*yk1^2+w8*yk2^2+w9*uk1*uk2+w10*uk1*yk1+w11*uk1*yk2+w12*uk2*yk1+w13*uk2*yk2+w14*yk1*yk2;
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14];
        fi = [uk1 uk2 yk1 yk2];
        wnum = 14;
        unum = 2;
        ynum = 2;
    case 'kg2r3p'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 w25 w26 w27 w28 w29 w30 w31 w32 w33 w34 uk1 uk2 yk1 yk2
        y = w1*uk1+w2*uk2+w3*yk1+w4*yk2+w5*uk1^2+w6*uk2^2+w7*yk1^2+w8*yk2^2+w9*uk1*uk2+w10*uk1*yk1+w11*uk1*yk2+w12*uk2*yk1+w13*uk2*yk2+w14*yk1*yk2+w15*uk1^3+w16*uk2^3+w17*yk1^3+w18*yk2^3+w19*uk1^2*uk2+w20*uk1^2*yk1+w21*uk1^2*yk2+w22*uk2^2*uk1+w23*uk2^2*yk1+w24*uk2^2*yk2+w25*yk1^2*uk1+w26*yk1^2*uk2+w27*yk1^2*yk2+w28*yk2^2*uk1+w29*yk2^2*uk2+w30*yk2^2*yk1+w31*uk1*uk2*yk1+w32*uk1*uk2*yk2+w33*uk1*yk1*yk2+w34*uk2*yk1*yk2;
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 w25 w26 w27 w28 w29 w30 w31 w32 w33 w34];
        fi = [uk1 uk2 yk1 yk2];
        wnum = 34;
        unum = 2;
        ynum = 2;
    case 'kg3r2p'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 w25 w26 w27 uk1 uk2 uk3 yk1 yk2 yk3
        y = w1*uk1+w2*uk2+w3*uk3+w4*yk1+w5*yk2+w6*yk3+w7*uk1^2+w8*uk2^2+w9*uk3^2+w10*yk1^2+w11*yk2^2+w12*yk3^2+w13*uk1*uk2+w14*uk1*uk3+w15*uk1*yk1+w16*uk1*yk2+w17*uk1*yk3+w18*uk2*uk3+w19*uk2*yk1+w20*uk2*yk2+w21*uk2*yk3+w22*uk3*yk1+w23*uk3*yk2+w24*uk3*yk3+w25*yk1*yk2+w26*yk1*yk3+w27*yk2*yk3;
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 w25 w26 w27];
        fi = [uk1 uk2 uk3 yk1 yk2 yk3];
        wnum = 27;
        unum = 3;
        ynum = 3;
    case 'nn1i2n2r'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 uk1 uk2 yk1 yk2
        y = w11*tanh(w1+w2*uk1+w3*uk2-w4*yk1-w5*yk2)+w12*tanh(w6+w7*uk1+w8*uk2-w9*yk1-w10*yk2);
%         y = w11*tanh(w1+w2*uk1+w3*uk2-w4*yk1-w5*yk2)+w12*(w6+w7*uk1+w8*uk2-w9*yk1-w10*yk2);
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12];
        fi = [uk1 uk2 yk1 yk2];
        wnum = 12;
        unum = 2;
        ynum = 2;
    case 'nn1i3n2r'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 uk1 uk2 yk1 yk2
        y = w16*tanh(w1+w2*uk1+w3*uk2-w4*yk1-w5*yk2)+w17*tanh(w6+w7*uk1+w8*uk2-w9*yk1-w10*yk2)+w18*tanh(w11+w12*uk1+w13*uk2-w14*yk1-w15*yk2);
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18];
        fi = [uk1 uk2 yk1 yk2];
        wnum = 18;
        unum = 2;
        ynum = 2;
    case 'nn1i4n2r'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 uk1 uk2 yk1 yk2
        y = w21*tanh(w1+w2*uk1+w3*uk2-w4*yk1-w5*yk2)+w22*tanh(w6+w7*uk1+w8*uk2-w9*yk1-w10*yk2)+w23*tanh(w11+w12*uk1+w13*uk2-w14*yk1-w15*yk2)+w24*tanh(w16+w17*uk1+w18*uk2-w19*yk1-w20*yk2);
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24];
        fi = [uk1 uk2 yk1 yk2];
        wnum = 24;
        unum = 2;
        ynum = 2;
    case 'nn2i2n2n2r'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 uk1 uk2 yk1 yk2
        y = w17*tanh(w11+w12*tanh(w1+w2*uk1+w3*uk2-w4*yk1-w5*yk2)+w13*tanh(w6+w7*uk1+w8*uk2-w9*yk1-w10*yk2))+w18*tanh(w14+w15*tanh(w1+w2*uk1+w3*uk2-w4*yk1-w5*yk2)+w16*tanh(w6+w7*uk1+w8*uk2-w9*yk1-w10*yk2));
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18];
        fi = [uk1 uk2 yk1 yk2];
        wnum = 18;
        unum = 2;
        ynum = 2;
    case 'nn2i3n2n2r'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 w25 uk1 uk2 yk1 yk2
        y = w24*tanh(w16+w17*tanh(w1+w2*uk1+w3*uk2-w4*yk1-w5*yk2)+w18*tanh(w6+w7*uk1+w8*uk2-w9*yk1-w10*yk2)+w19*tanh(w11+w12*uk1+w13*uk2-w14*yk1-w15*yk2))+w25*tanh(w20+w21*tanh(w1+w2*uk1+w3*uk2-w4*yk1-w5*yk2)+w22*tanh(w6+w7*uk1+w8*uk2-w9*yk1-w10*yk2)+w23*tanh(w11+w12*uk1+w13*uk2-w14*yk1-w15*yk2));
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 w25];
        fi = [uk1 uk2 yk1 yk2];
        wnum = 25;
        unum = 2;
        ynum = 2;
    case 'nn2i2n3n2r'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 uk1 uk2 yk1 yk2
        y = w20*tanh(w11+w12*tanh(w1+w2*uk1+w3*uk2-w4*yk1-w5*yk2)+w13*tanh(w6+w7*uk1+w8*uk2-w9*yk1-w10*yk2))+w21*tanh(w14+w15*tanh(w1+w2*uk1+w3*uk2-w4*yk1-w5*yk2)+w16*tanh(w6+w7*uk1+w8*uk2-w9*yk1-w10*yk2))+w22*tanh(w17+w18*tanh(w1+w2*uk1+w3*uk2-w4*yk1-w5*yk2)+w19*tanh(w6+w7*uk1+w8*uk2-w9*yk1-w10*yk2));
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22];
        fi = [uk1 uk2 yk1 yk2];
        wnum = 22;
        unum = 2;
        ynum = 2;
    case 'nn2i3n3n2r'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 w25 w26 w27 w28 w29 w30 uk1 uk2 yk1 yk2
        y = w28*tanh(w16+w17*tanh(w1+w2*uk1+w3*uk2-w4*yk1-w5*yk2)+w18*tanh(w6+w7*uk1+w8*uk2-w9*yk1-w10*yk2)+w19*tanh(w11+w12*uk1+w13*uk2-w14*yk1-w15*yk2))+w29*tanh(w20+w21*tanh(w1+w2*uk1+w3*uk2-w4*yk1-w5*yk2)+w22*tanh(w6+w7*uk1+w8*uk2-w9*yk1-w10*yk2)+w23*tanh(w11+w12*uk1+w13*uk2-w14*yk1-w15*yk2))+w30*tanh(w24+w25*tanh(w1+w2*uk1+w3*uk2-w4*yk1-w5*yk2)+w26*tanh(w6+w7*uk1+w8*uk2-w9*yk1-w10*yk2)+w27*tanh(w11+w12*uk1+w13*uk2-w14*yk1-w15*yk2));
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 w25 w26 w27 w28 w29 w30];
        fi = [uk1 uk2 yk1 yk2];
        wnum = 30;
        unum = 2;
        ynum = 2;
    case 'nn1i2n3r'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 uk1 uk2 uk3 yk1 yk2 yk3
        y = w15*tanh(w1+w2*uk1+w3*uk2+w4*uk3-w5*yk1-w6*yk2-w7*yk3)+w16*tanh(w8+w9*uk1+w10*uk2+w11*uk3-w12*yk1-w13*yk2-w14*yk3);
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16];
        fi = [uk1 uk2 uk3 yk1 yk2 yk3];
        wnum = 16;
        unum = 3;
        ynum = 3;   
    case 'nn1i3n3r'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 uk1 uk2 uk3 yk1 yk2 yk3
        y = w22*tanh(w1+w2*uk1+w3*uk2+w4*uk3-w5*yk1-w6*yk2-w7*yk3)+w23*tanh(w8+w9*uk1+w10*uk2+w11*uk3-w12*yk1-w13*yk2-w14*yk3)+w24*tanh(w15+w16*uk1+w17*uk2+w18*uk3-w19*yk1-w20*yk2-w21*yk3);
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24];
        fi = [uk1 uk2 uk3 yk1 yk2 yk3];
        wnum = 24;
        unum = 3;
        ynum = 3;
    case 'nn1i4n3r'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 w25 w26 w27 w28 w29 w30 w31 w32 uk1 uk2 uk3 yk1 yk2 yk3
        y = w29*tanh(w1+w2*uk1+w3*uk2+w4*uk3-w5*yk1-w6*yk2-w7*yk3)+w30*tanh(w8+w9*uk1+w10*uk2+w11*uk3-w12*yk1-w13*yk2-w14*yk3)+w31*tanh(w15+w16*uk1+w17*uk2+w18*uk3-w19*yk1-w20*yk2-w21*yk3)+w32*tanh(w22+w23*uk1+w24*uk2+w25*uk3-w26*yk1-w27*yk2-w28*yk3);
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 w25 w26 w27 w28 w29 w30 w31 w32];
        fi = [uk1 uk2 uk3 yk1 yk2 yk3];
        wnum = 32;
        unum = 3;
        ynum = 3;
    case 'nn2i2n2n3r'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 uk1 uk2 uk3 yk1 yk2 yk3
        y = w21*tanh(w15+w16*tanh(w1+w2*uk1+w3*uk2+w4*uk3-w5*yk1-w6*yk2-w7*yk3)+w17*tanh(w8+w9*uk1+w10*uk2+w11*uk3-w12*yk1-w13*yk2-w14*yk3))+w22*tanh(w18+w19*tanh(w1+w2*uk1+w3*uk2+w4*uk3-w5*yk1-w6*yk2-w7*yk3)+w20*tanh(w8+w9*uk1+w10*uk2+w11*uk3-w12*yk1-w13*yk2-w14*yk3));
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22];
        fi = [uk1 uk2 uk3 yk1 yk2 yk3];
        wnum = 22;
        unum = 3;
        ynum = 3;
    case 'nn2i3n2n3r'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 w25 w26 w27 w28 w29 w30 w31 uk1 uk2 uk3 yk1 yk2 yk3
        y = w30*tanh(w22+w23*tanh(w1+w2*uk1+w3*uk2+w4*uk3-w5*yk1-w6*yk2-w7*yk3)+w24*tanh(w8+w9*uk1+w10*uk2+w11*uk3-w12*yk1-w13*yk2-w14*yk3)+w25*tanh(w15+w16*uk1+w17*uk2+w18*uk3-w19*yk1-w20*yk2-w21*yk3))+w31*tanh(w26+w27*tanh(w1+w2*uk1+w3*uk2+w4*uk3-w5*yk1-w6*yk2-w7*yk3)+w28*tanh(w8+w9*uk1+w10*uk2+w11*uk3-w12*yk1-w13*yk2-w14*yk3)+w29*tanh(w15+w16*uk1+w17*uk2+w18*uk3-w19*yk1-w20*yk2-w21*yk3));
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 w25 w26 w27 w28 w29 w30 w31];
        fi = [uk1 uk2 uk3 yk1 yk2 yk3];
        wnum = 31;
        unum = 3;
        ynum = 3;
    case 'nn2i2n3n3r'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 w25 w26 uk1 uk2 uk3 yk1 yk2 yk3
        y = w24*tanh(w15+w16*tanh(w1+w2*uk1+w3*uk2+w4*uk3-w5*yk1-w6*yk2-w7*yk3)+w17*tanh(w8+w9*uk1+w10*uk2+w11*uk3-w12*yk1-w13*yk2-w14*yk3))+w25*tanh(w18+w19*tanh(w1+w2*uk1+w3*uk2+w4*uk3-w5*yk1-w6*yk2-w7*yk3)+w20*tanh(w8+w9*uk1+w10*uk2+w11*uk3-w12*yk1-w13*yk2-w14*yk3))+w26*tanh(w21+w22*tanh(w1+w2*uk1+w3*uk2+w4*uk3-w5*yk1-w6*yk2-w7*yk3)+w23*tanh(w8+w9*uk1+w10*uk2+w11*uk3-w12*yk1-w13*yk2-w14*yk3));
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 w25 w26];
        fi = [uk1 uk2 uk3 yk1 yk2 yk3];
        wnum = 26;
        unum = 3;
        ynum = 3;
    case 'nn2i3n3n3r'
        syms y w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 w25 w26 w27 w28 w29 w30 w31 w32 w33 w34 w35 w36 uk1 uk2 uk3 yk1 yk2 yk3
        y = w34*tanh(w22+w23*tanh(w1+w2*uk1+w3*uk2+w4*uk3-w5*yk1-w6*yk2-w7*yk3)+w24*tanh(w8+w9*uk1+w10*uk2+w11*uk3-w12*yk1-w13*yk2-w14*yk3)+w25*tanh(w15+w16*uk1+w17*uk2+w18*uk3-w19*yk1-w20*yk2-w21*yk3))+w35*tanh(w26+w27*tanh(w1+w2*uk1+w3*uk2+w4*uk3-w5*yk1-w6*yk2-w7*yk3)+w28*tanh(w8+w9*uk1+w10*uk2+w11*uk3-w12*yk1-w13*yk2-w14*yk3)+w29*tanh(w15+w16*uk1+w17*uk2+w18*uk3-w19*yk1-w20*yk2-w21*yk3))+w36*tanh(w30+w31*tanh(w1+w2*uk1+w3*uk2+w4*uk3-w5*yk1-w6*yk2-w7*yk3)+w32*tanh(w8+w9*uk1+w10*uk2+w11*uk3-w12*yk1-w13*yk2-w14*yk3)+w33*tanh(w15+w16*uk1+w17*uk2+w18*uk3-w19*yk1-w20*yk2-w21*yk3));
        w = [w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19 w20 w21 w22 w23 w24 w25 w26 w27 w28 w29 w30 w31 w32 w33 w34 w35 w36];
        fi = [uk1 uk2 uk3 yk1 yk2 yk3];
        wnum = 36;
        unum = 3;
        ynum = 3;
    otherwise
        disp('Wrong model name!')
end
end