clear all; close all; clc;
%==============================ARX=========================================
%2. rad: 'arx2r'  
%3. rad: 'arx3r'  
%4. rad: 'arx4r'
%==================Non-Linear Diferential Equation=========================
%2. rad: 'nde2r2p' ; 'nde2r3p'     
%3. rad: 'nde3r2p' ; 'nde3r3p' 
%=====================Parametric Volterra Series===========================
%2. rad: 'pvs2r2p' ; 'pvs2r3p' 
%3. rad: 'pvs3r2p' ; 'pvs3r3p'
%=======================Kolmogorov-Gabor===================================
%2. rad: 'kg2r2p' ; 'kg2r3p'
%3. rad: 'kg3r2p'
%=========================Neural Network===================================
%1. vrstva, 2. rad: 'nn1i2n2r' ; 'nn1i3n2r' ; 'nn1i4n2r' 
%1. vrstva, 3. rad: 'nn1i2n3r' ; 'nn1i3n3r' ; 'nn1i4n3r'
%2. vrstvy, 2. rad: 'nn2i2n2n2r' ; 'nn2i3n2n2r' ; 'nn2i2n3n2r' ; 'nn2i3n3n2r' 
%2. vrstvy, 3. rad: 'nn2i2n2n3r' ; 'nn2i3n2n3r' ; 'nn2i2n3n3r' ; 'nn2i3n3n3r'
%============================Metody========================================
%Steepest Descent:    'sd'
%Kvazi-Newtonova:     'kn'
%Levenberg-Marquardt: 'lm'

model = 'nn2i2n3n3r';          %vyber modelu
iterm = 1500;               %maximalni pocet iteraci
% window = 2000;              %1:window...validace, window:end...estimace
%or
testim = 50;              %1 az t...validace, t az end...estimace
regu = 1;                   %zmenseni vstupniho signalu regu-krat
regy = 1;                  %zmenseni vystupniho signalu regy-krat
gm = 'lm';                  %vyber gradientni metody
alfa = 0.5;                 %Levenberg-Marquardt only
wrndm = 2;                  %velikost vah pri inicializaci <-wrndm/2;wrndm/2>
td = 0.1;                     %dopravni zpozdeni v sekundach
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% N A C T E N I     S T R U K T U R Y     M O D E L U
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[sy sw sfi wnum unum ynum] = fmodel(model);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% V Y P I S     S T R U K T U R Y 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('Zadani-------------------------------------------------------------')
syp = char(sy);
disp(['y = ' syp])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% V Y P O C E T     C H Y B Y
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('Chyba--------------------------------------------------------------')
se = char(sy);
for i=wnum:-1:1
    se = strrep(se,['w' num2str(i)],['w(' num2str(i) ')']);
end
se = strrep(se,'^','.^');
se = strrep(se,'*','.*');
disp(['E = Y - (' se ');'])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% V Y P O C E T     J A C O B I A N U
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('Jacobian-----------------------------------------------------------')
pomJ = jacobian(sy,sw);
sJ = char(pomJ);
for i=wnum:-1:1
    sJ = strrep(sJ,['w' num2str(i)],['w(' num2str(i) ')']);
end
sJ = strrep(sJ,'matrix([','-');
sJ = strrep(sJ,'])',';');
sJ = strrep(sJ,'*','.*');
sJ = strrep(sJ,'^','.^');

column = strfind(sJ,',');
column = [2 column length(sJ)-1];
for i=1:length(column)-1
    crc = zeros(1,unum+ynum);
    ii=1;
    for j=1:unum
       if(strfind(sJ(column(i):column(i+1)-1),['uk' num2str(j)])); crc(ii)=1; end;
       ii=ii+1;
    end
    for j=1:ynum
       if(strfind(sJ(column(i):column(i+1)-1),['yk' num2str(j)])); crc(ii)=1; end;
       ii=ii+1;
    end
    crcJ(i) = sum(crc);
end
for i=length(crcJ):-1:1
    if(crcJ(i)==0)
        sJ = [sJ(1:column(i)) '('  sJ(column(i)+1:column(i+1)-1) ').*ones(N,1)' sJ(column(i+1):end)];
    end
end  
disp(['J = ' sJ])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% V Y P O C E T     O P T I M A L N I     E T Y
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('Eta optim----------------------------------------------------------')
etaY = char(sy);
for i=wnum:-1:1
    etaY = strrep(etaY,['w' num2str(i)],['(xw(' num2str(i) ')-xeta*xp(' num2str(i) '))']);
end
etaY = strrep(etaY,'^','.^');
etaY = strrep(etaY,'*','.*');
etaY = strrep(etaY,'uk','xuk');
etaY = strrep(etaY,'yk','xyk');
disp(['xE = xY - (' etaY ');'])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% V Y P O C E T     L I N E A R I Z O V A N E H O     M O D E L U
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('Linearizace--------------------------------------------------------')
pomL = jacobian(sy,sfi);
sL = char(pomL);
for i=wnum:-1:1
    sL = strrep(sL,['w' num2str(i)],['w(' num2str(i) ')']);
end
for i=unum:-1:1
    sL = strrep(sL,['uk' num2str(i)],['u(i-' num2str(i) ')']);
end
for i=ynum:-1:1
    sL = strrep(sL,['yk' num2str(i)],['yl(i-' num2str(i) ')']);
end
sL = strrep(sL,'matrix([','');
sL = strrep(sL,'])','');
mpom = strfind(sL,',');
mpom = [1 mpom length(sL)];
Lf = '';
for i=1:unum
    Lf = [Lf '(' sL(mpom(i)+1:mpom(i+1)-1) ')*u(i-' num2str(i) ')+'];
    eval(['b' num2str(i) '=''' sL(mpom(i)+1:mpom(i+1)-1) ''';']);
end
for i=1:ynum
    Lf = [Lf '(' sL(mpom(unum+i)+1:mpom(unum+i+1)-1) ')*yl(i-' num2str(i) ')+'];
    eval(['a' num2str(i) '= ''' sL(mpom(unum+i)+1:mpom(unum+i+1)-1) ''';']);
end
disp(['ylin = ' Lf(1:end-1) ';'])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% V Y P O C E T     P R E D I K C E
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('Predikce-----------------------------------------------------------')
for i=wnum:-1:1
    syp = strrep(syp,['w' num2str(i)],['w(' num2str(i) ')']);
end
for i=unum:-1:1
    syp = strrep(syp,['uk' num2str(i)],['u(i-' num2str(i) ')']);
end
for i=ynum:-1:1
    syp = strrep(syp,['yk' num2str(i)],['ym(i-' num2str(i) ')']);
end
disp(['ym(i) = ' syp ';'])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% E S T I M A C E     P A R A M E T R U     +     V Y H O D N O C E N I
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('Estimace-----------------------------------------------------------')
blank